'use client';

import s from './styles.module.scss';
import { Button, Input, PhoneInput } from '@shared/ui';
import Image from 'next/image';
import toast from 'react-hot-toast';
import { Controller, useForm } from 'react-hook-form';
import { zodResolver } from '@hookform/resolvers/zod';
import { z } from 'zod';

import bgForm from '@public/images/bg-form.jpg';
import { sendFormFn } from '@shared/api/api.service';
import { isValidPhoneNumber } from 'libphonenumber-js/min';

const FormSchema = z.object({
  name: z
    .string()
    .min(3, { message: 'Поле должно содержать не менее 3-х букв' })
    .regex(/^[A-Za-zА-Яа-яЁё]+(?:[ '-][A-Za-zА-Яа-яЁё]+)*$/, {
      message: 'Поле содержит некорректные символы',
    }),
  phone: z.string().refine(isValidPhoneNumber, 'Некорректный номер телефона'),
});
type TForm = z.infer<typeof FormSchema>;

const defaultValues = {
  name: '',
  phone: '',
};

export default function ContactsForm() {
  const {
    handleSubmit,
    control,
    reset,
    clearErrors,
    formState: { errors },
  } = useForm<TForm>({
    mode: 'onSubmit',
    reValidateMode: 'onBlur',
    resolver: zodResolver(FormSchema),
    defaultValues,
  });

  const onSubmit = async (data: TForm) => {
    const payload = {
      ...data,
      form: 'contacts-form',
    };

    try {
      await sendFormFn(payload);
      toast.success('Заявка на консультацию принята');
      reset(defaultValues);
    } catch (e) {
      toast.error('Ошибка при отправке заявки...', {
        duration: 3000,
      });
    }
  };

  return (
    <div className={s.Form}>
      <Image
        className={s.Background}
        src={bgForm}
        placeholder='blur'
        alt={''}
        quality={75}
        fill
        priority
      />
      <div className={s.Offer}>
        <h3 className={s.Title}>Остались вопросы?</h3>
        <p className={s.SubTitle}>
          Наш эксперт свяжется с вами для уточнения подробностей и определения
          точной стоимости работ
        </p>
      </div>
      <form className={s.Inputs} onSubmit={handleSubmit(onSubmit)}>
        <Controller
          control={control}
          name={'name'}
          render={({ field }) => (
            <Input
              {...field}
              placeholder={'Ваше имя'}
              fullWidth
              onChange={(e) => {
                clearErrors('name');
                field.onChange(e);
              }}
              error={errors && errors.name?.message}
              errorTextColor={'#ff9191'}
            />
          )}
        />
        <Controller
          control={control}
          name={'phone'}
          render={({ field }) => (
            <PhoneInput
              {...field}
              placeholder={'+7 (999) 123-45-67'}
              fullWidth
              onChange={(e) => {
                clearErrors('phone');
                field.onChange(e);
              }}
              error={errors && errors.phone?.message}
              errorTextColor={'#ff9191'}
            />
          )}
        />
        <Button variant='orange' fullWidth>
          Получить консультацию
        </Button>
      </form>
    </div>
  );
}
